import java.util.Scanner;
import java.util.Stack;


public class Calculator {
	public static void main(String[] args)
	{
		Calculator a = new Calculator();
		System.out.println(a.convert("( 210.5 * ( 3 + 1 ) ) * ( 2 - 1 )")); //TESTERS
		System.out.println(a.calculate(a.convert(" 210.5 * ( 3 + 1 )  + ( 2 - 1 )"))); //TESTER
	}
	public String convert(String equation)
	{
		String post = "";
		Stack<String> operators = new Stack<String>();
		operators.push("$");
		Scanner scan = new Scanner(equation);
		while(scan.hasNext())
		{
			String s = scan.next();
			if(s.equals("+") || s.equals("*") || s.equals("-") || s.equals("/")
					|| s.equals("(") || s.equals(")"))
			{
				post += convert(s, operators, "") + " ";
			}
			else if(s.equals(" "))
			{
				post += " ";
			}
			else
			{
				post += s + " ";
			}
		}
		while(!operators.peek().equals("$"))
		{
			post += operators.pop() + " ";
		}
		return post;
	}
	private  String convert(String currentOp, Stack<String> operators, String post)
	{
		
		if(operators.peek().equals("$"))	//first operator we encounter in the equation
		{
			operators.push(currentOp);
			return "";
		}
		else
		{
			//if the operator on the top of stack has a higher or equal precedence
			if((operators.peek().equals("*") || operators.peek().equals("/")) && 
					(currentOp.equals("+") || currentOp.equals("-") || currentOp.equals(operators.peek())))//-----> this sentence is for the equal precedence	
			{
				String op = operators.pop();
				operators.push(currentOp);
				post += op;
			}
			//if the operator on the top has a less precedence
			else if((operators.peek().equals("+") || operators.peek().equals("-")) && ((currentOp.equals("*") || currentOp.equals("/"))))
				operators.push(currentOp);
			else if(operators.peek().equals("(") && (currentOp.equals("+") || currentOp.equals("-") || currentOp.equals("*") || currentOp.equals("/")))
				operators.push(currentOp);
			else if(currentOp.equals("("))
				operators.push(currentOp);
			else if(currentOp.equals(")"))
			{
				while(!operators.peek().equals("$"))
				{
					if(operators.peek().equals("("))
					{
						operators.pop();
						break;	//we keep popping until we reach a left paran
					}
					else
						post += operators.pop() + " ";
				}
			}
		}
		return post;
	}
	//method that calculates the postfi statement
	//prerequisite: the equation must be a postfix statement
	public Double calculate(String postFix)
	{
		Stack<String> operands = new Stack<String>();
		Scanner scan = new Scanner(postFix);
		while(scan.hasNext())
		{
			String s = scan.next();
			if(s.equals("+") || s.equals("-") || s.equals("*") || s.equals("/")
					|| s.equals("(") || s.equals(")"))
			{
				double a = Double.parseDouble(operands.pop());
				double b = Double.parseDouble(operands.pop());
				if(s.equals("+"))
					operands.push(a + b + "");
				else if(s.equals("-"))
					operands.push(b - a + "");
				else if(s.equals("*"))
					operands.push(a*1. * b + "");
				else if(s.equals("/"))
					operands.push(b * 1. / a + "");
			}
			else if(s.equals(" ")) { //do nothing
			
			}
			else	//for the numbers
			{
				operands.push(s);
			}
		}	
		return Double.parseDouble(operands.pop());
	}	
}