import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/*Ghassan Fakher
 * gkf01
section 4 */



public class BuildTree {
	static Map<Character, String> dictionary = new HashMap<Character, String>(); //in order to make the building of the dictionary much easier although it is not good to put static variables outside main method
	public static void main(String[] args) throws FileNotFoundException
	{
		ArrayList<Node> frequencies = readFile(new File("data.txt"));
		frequencies = sortList(frequencies);
		Node base = buildTree(frequencies);
		System.out.println(base.toString());
		generateCode(base, "");
		
		System.out.println(dictionary.toString());
		
		
		createCompressedFile(dictionary);
	}
	private static ArrayList<Node> sortList(ArrayList<Node> frequencies)
	{
		for(int i = 0; i < frequencies.size(); i++)
		{
			for(int j = 0; j < i; j++)
			{
				if(frequencies.get(i).compareTo(frequencies.get(j)) == -1)
				{
					Node temp = new Node( frequencies.get(j));
					frequencies.set(j, new Node(frequencies.get(i)));
					frequencies.set(i, temp);
				}
			}
		}
		return frequencies;
	}
	public static Node buildTree(ArrayList<Node> frequencies)
	{
		ArrayList<Node> copy = new ArrayList<Node>(frequencies);
		Node node = new Node(frequencies.get(0).getFrequency() + frequencies.get(1).getFrequency(), frequencies.get(0), frequencies.get(1), '=');
		return buildTree(frequencies, node, 2);
		
	}
	private static Node buildTree(ArrayList<Node> frequencies, Node node, int i)
	{
		if(i == frequencies.size())
		{
			//do nothing
		}
		else
		{
			node = new Node(frequencies.get(i).getFrequency() + node.getFrequency(), node, frequencies.get(i), '-');
			i += 1;
			return buildTree(frequencies, node, i);
		}
		return node;
	}
	public static ArrayList<Node> readFile(File input) throws FileNotFoundException
	{
		Scanner scan = new Scanner(input);
		String letters = "abcdefghijklmnopqrstuvwxyz";
		int[] frequencies = new int[letters.length()];
		while(scan.hasNext())
		{
			String s = scan.next().toLowerCase();
			if(!s.equals(" "))
			{
				for(int i = 0; i < s.length(); i++)
				{
					if(letters.contains(s.charAt(i) + ""))
					{
						frequencies[letters.indexOf(s.charAt(i))]++;
					}
				}
			}	
		}
		ArrayList<Node> nodes = new ArrayList<Node>();
		for(int i = 0; i < frequencies.length; i++)
		{
			nodes.add(new Node(frequencies[i] , null, null, letters.charAt(i)));
		}
		return  nodes;
	}
	public static void generateCode(Node node, String code)
	{
		Node temp = new Node(node);
		//map the corresponding letter to its code if we reach the leaves
		if(temp.getRight()==(null) && temp.getLeft()==(null))
		{
			dictionary.put(temp.getLetter(), code);
		}
		else
		{
			temp = temp.getRight();
			code += "0";	//when i go right i will put a zero not a one because i have my tree sorted base not like the regular trees...
			generateCode(temp, code);
			if(code.length() <= 1)
			{
				code = "";
			}
			else {	//in order to remove the code of the branch we entered lately
				code = code.substring(0, code.length() - 1);
			}
			
			node = node.getLeft();	//backtracking
			temp = node;
			
			code += "1";
			generateCode(temp, code);
		}
	}
	
	
	public static void createCompressedFile(Map<Character, String> dictionary) throws FileNotFoundException
	{
		StringBuilder builder = new StringBuilder();
		Scanner scan = new Scanner(new File("data.txt"));
		
		while(scan.hasNext())
		{
			String read = scan.next().toLowerCase();
			for(int i = 0; i < read.length(); i++)
			{
				builder.append(dictionary.get(read.charAt(i)));
			}
		}
		System.out.println(builder.capacity());
		toByteArray(builder);
		
	}
	//there still remain to fix the remaining char in the char sequence
	public static void toByteArray(StringBuilder builder) throws FileNotFoundException
	{
		byte[] b = new byte[builder.length()];
		for(int i = 0; i < builder.length() - 8 ; i = i + 8)
		{
			CharSequence binary = builder.subSequence(i, i + 8);
			
			byte d = (byte)(integerfrmbinary(binary));
			b[i] = d;
		}
		PrintStream print = new PrintStream(new File("compressed.txt"));
		printToFile(print, b);
	}
	private static void printToFile(PrintStream print, byte[] b)
	{
		print.print(Arrays.toString(b));
	}
	public static int integerfrmbinary(CharSequence str){
	    double j=0;
	    for(int i=0;i<str.length();i++){
	        if(str.charAt(i)== '1'){
	         j=j+ Math.pow(2,str.length()-1-i);
	     }

	    }
	    return (int) j;
	}
}
